/* A Bison parser, made from parser.y, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TK_ERROR = 258,
     TK_EOF = 259,
     TK_COMA = 260,
     TK_LPAR = 261,
     TK_RPAR = 262,
     TK_AMP = 263,
     TK_COLON = 264,
     TK_LBRA = 265,
     TK_RBRA = 266,
     TK_DOLLAR = 267,
     TK_STAR = 268,
     TK_EQUAL = 269,
     TK_INT = 270,
     TK_REAL = 271,
     TK_IDENT = 272,
     TK_STRING = 273,
     FILE_NAME = 274,
     PL_CODE = 275,
     PL_JUMP = 276,
     PL_CALL = 277,
     PL_FAIL = 278,
     PL_RET = 279,
     JUMP = 280,
     MOVE = 281,
     CALL_C = 282,
     JMP_REG = 283,
     RET_REG = 284,
     JUMP_RET = 285,
     FAIL_RET = 286,
     TRUE_RET = 287,
     FAIL_C_RET = 288,
     TRUE_C_RET = 289,
     MOVE_RET = 290,
     C_CODE = 291,
     C_RET = 292,
     LONG = 293,
     LOCAL = 294,
     GLOBAL = 295,
     REG = 296,
     CST = 297
   };
#endif
#define TK_ERROR 258
#define TK_EOF 259
#define TK_COMA 260
#define TK_LPAR 261
#define TK_RPAR 262
#define TK_AMP 263
#define TK_COLON 264
#define TK_LBRA 265
#define TK_RBRA 266
#define TK_DOLLAR 267
#define TK_STAR 268
#define TK_EQUAL 269
#define TK_INT 270
#define TK_REAL 271
#define TK_IDENT 272
#define TK_STRING 273
#define FILE_NAME 274
#define PL_CODE 275
#define PL_JUMP 276
#define PL_CALL 277
#define PL_FAIL 278
#define PL_RET 279
#define JUMP 280
#define MOVE 281
#define CALL_C 282
#define JMP_REG 283
#define RET_REG 284
#define JUMP_RET 285
#define FAIL_RET 286
#define TRUE_RET 287
#define FAIL_C_RET 288
#define TRUE_C_RET 289
#define MOVE_RET 290
#define C_CODE 291
#define C_RET 292
#define LONG 293
#define LOCAL 294
#define GLOBAL 295
#define REG 296
#define CST 297




/* Copy the first part of user declarations.  */
#line 1 "parser.y"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "./buffer.h"
#include "./ma2asm.h"

#include "config.h"             /* in Runtime */
#include "bigloo.h"             /* in Runtime */
#include "archi.h"              /* in Runtime */
#include "fol.h"                /* in Runtime */
    
int kind_of_call;   /* 1: prolog 0: call */

int in_ident;
int init_already_read;
int offset;

#define YYDEBUG 1 
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
#line 23 "parser.y"
typedef union {
    long   num;
    float fnum;
    char *str;
    InitLongList_t initlonglist;
    struct {
         short  type;
	 long   value;
    }    initlongval;
    struct {
	 char  name;
	 long no;
    }	 reg;
    struct {
        char *ident;
        long trail;
    }    ident;
} yystype;
/* Line 193 of /usr/share/bison/yacc.c.  */
#line 198 "parser.c"
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */


/* Line 213 of /usr/share/bison/yacc.c.  */
#line 219 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
#define YYLAST   149

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  43
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  22
/* YYNRULES -- Number of rules. */
#define YYNRULES  73
/* YYNRULES -- Number of states. */
#define YYNSTATES  133

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   297

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    14,    16,    18,    20,
      22,    25,    30,    35,    40,    48,    56,    62,    68,    70,
      75,    81,    84,    88,    90,    92,    94,    96,    98,   101,
     104,   108,   110,   115,   118,   120,   122,   127,   128,   135,
     139,   142,   143,   150,   154,   157,   158,   165,   166,   168,
     170,   174,   176,   178,   180,   182,   185,   190,   193,   195,
     198,   200,   202,   203,   206,   207,   211,   214,   215,   218,
     223,   225,   229,   231
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      44,     0,    -1,    -1,    44,    45,    -1,    19,    18,    -1,
      20,    46,    58,    -1,    48,    -1,    50,    -1,    23,    -1,
      24,    -1,    25,    58,    -1,    26,    47,     5,    47,    -1,
      26,    15,     5,    47,    -1,    26,    15,     5,    61,    -1,
      26,    42,     6,    57,     7,     5,    47,    -1,    26,    42,
       6,    57,     7,     5,    61,    -1,    26,     8,    61,     5,
      47,    -1,    26,     8,    61,     5,    61,    -1,    52,    -1,
      28,    47,     5,    58,    -1,    28,     8,    61,     5,    58,
      -1,    29,    47,    -1,    29,     8,    61,    -1,    30,    -1,
      31,    -1,    32,    -1,    33,    -1,    34,    -1,    35,    47,
      -1,    35,    61,    -1,    36,    46,    58,    -1,    37,    -1,
      38,    46,    61,    62,    -1,    58,     9,    -1,    39,    -1,
      40,    -1,    41,     6,    15,     7,    -1,    -1,    21,    58,
      49,     6,    54,     7,    -1,    21,     8,    47,    -1,    21,
      13,    -1,    -1,    22,    58,    51,     6,    54,     7,    -1,
      22,     8,    47,    -1,    22,    13,    -1,    -1,    27,    58,
      53,     6,    54,     7,    -1,    -1,    55,    -1,    56,    -1,
      55,     5,    56,    -1,    15,    -1,    16,    -1,    18,    -1,
      47,    -1,     8,    47,    -1,    42,     6,    57,     7,    -1,
      12,    15,    -1,    61,    -1,     8,    61,    -1,    15,    -1,
      16,    -1,    -1,    59,    17,    -1,    -1,    10,    15,    11,
      -1,    58,    60,    -1,    -1,    14,    64,    -1,    14,    10,
      63,    11,    -1,    64,    -1,    64,     5,    63,    -1,    15,
      -1,    58,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,    86,    86,    87,    92,    94,    95,    96,    97,    98,
      99,   100,   103,   104,   105,   106,   107,   109,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   129,   131,   134,   139,   138,   143,
     147,   152,   151,   156,   160,   165,   164,   169,   170,   173,
     175,   178,   180,   181,   182,   183,   184,   185,   186,   187,
     190,   192,   196,   195,   199,   200,   203,   206,   207,   208,
     211,   212,   215,   216
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TK_ERROR", "TK_EOF", "TK_COMA", "TK_LPAR", 
  "TK_RPAR", "TK_AMP", "TK_COLON", "TK_LBRA", "TK_RBRA", "TK_DOLLAR", 
  "TK_STAR", "TK_EQUAL", "TK_INT", "TK_REAL", "TK_IDENT", "TK_STRING", 
  "FILE_NAME", "PL_CODE", "PL_JUMP", "PL_CALL", "PL_FAIL", "PL_RET", 
  "JUMP", "MOVE", "CALL_C", "JMP_REG", "RET_REG", "JUMP_RET", "FAIL_RET", 
  "TRUE_RET", "FAIL_C_RET", "TRUE_C_RET", "MOVE_RET", "C_CODE", "C_RET", 
  "LONG", "LOCAL", "GLOBAL", "REG", "CST", "$accept", "statements", 
  "statement", "local_or_global", "reg", "pl_jump", "@1", "pl_call", "@2", 
  "call_c", "@3", "args", "args2", "arg", "cst", "ident", "@4", 
  "ident_trail", "xident", "longinit", "initlonglist", "initlongval", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    43,    44,    44,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    45,    46,    46,    47,    49,    48,    48,
      48,    51,    50,    50,    50,    53,    52,    54,    54,    55,
      55,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      57,    57,    59,    58,    60,    60,    61,    62,    62,    62,
      63,    63,    64,    64
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     2,     3,     1,     1,     1,     1,
       2,     4,     4,     4,     7,     7,     5,     5,     1,     4,
       5,     2,     3,     1,     1,     1,     1,     1,     2,     2,
       3,     1,     4,     2,     1,     1,     4,     0,     6,     3,
       2,     0,     6,     3,     2,     0,     6,     0,     1,     1,
       3,     1,     1,     1,     1,     2,     4,     2,     1,     2,
       1,     1,     0,     2,     0,     3,     2,     0,     2,     4,
       1,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,    62,     1,     0,     0,    62,    62,     8,     9,    62,
       0,    62,     0,     0,    23,    24,    25,    26,    27,    62,
       0,    31,     0,     3,     6,     7,    18,     0,     0,     4,
      34,    35,    62,     0,    40,    37,     0,    44,    41,    10,
      62,     0,     0,     0,     0,    45,    62,     0,    62,    21,
      28,    64,    29,    62,    62,    33,    63,     5,    39,     0,
      43,     0,     0,    62,     0,     0,     0,     0,     0,    62,
      22,     0,    66,    30,    67,    47,    47,    62,    12,    13,
       0,    60,    61,     0,    11,    47,    62,    19,     0,    62,
      32,    62,     0,    51,    52,    53,     0,    54,     0,    48,
      49,    58,     0,    16,    17,    36,     0,     0,    20,    65,
      62,    72,    73,    68,    55,    59,    57,     0,    38,    62,
      42,    62,    46,     0,    70,     0,    50,    14,    15,    69,
      62,    56,    71
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     1,    23,    32,    97,    24,    59,    25,    61,    26,
      67,    98,    99,   100,    83,    51,    28,    72,   101,    90,
     123,   124
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -74
static const yysigned_char yypact[] =
{
     -74,   111,   -74,   -12,     3,    10,    25,   -74,   -74,   -74,
      24,   -74,    -6,     7,   -74,   -74,   -74,   -74,   -74,   -25,
       3,   -74,     3,   -74,   -74,   -74,   -74,    20,     2,   -74,
     -74,   -74,   -74,   -25,   -74,   -74,   -25,   -74,   -74,   -74,
     -74,    35,    38,    41,    44,   -74,   -74,    51,   -74,   -74,
     -74,    48,   -74,   -74,   -74,   -74,   -74,   -74,   -74,    56,
     -74,    63,    65,   -25,    57,    39,   -25,    68,    66,   -74,
     -74,    60,   -74,   -74,    62,     9,     9,   -25,   -74,   -74,
      70,   -74,   -74,    72,   -74,     9,   -74,   -74,    69,    31,
     -74,   -25,    67,   -74,   -74,   -74,    75,   -74,    76,    79,
     -74,   -74,    82,   -74,   -74,   -74,    85,    84,   -74,   -74,
      78,   -74,   -74,   -74,   -74,   -74,   -74,    39,   -74,    45,
     -74,   -25,   -74,    83,    90,    89,   -74,   -74,   -74,   -74,
      78,   -74,   -74
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -74,   -74,   -74,   -13,     1,   -74,   -74,   -74,   -74,   -74,
     -74,   -73,   -74,   -22,   -19,    -1,   -74,   -74,   -18,   -74,
     -31,    11
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -63
static const short yytable[] =
{
      27,    52,    46,   102,    35,    38,    29,    53,    39,    54,
      45,    44,   107,    47,    49,    48,    42,    91,    33,    56,
      50,    92,    62,    34,    93,    94,   -62,    95,    68,    55,
      70,    57,    40,    36,    58,    42,    74,    60,    37,    41,
      63,   110,    30,    31,    64,    79,   111,    65,    42,    66,
      42,    96,    73,    91,    81,    82,    69,    92,    71,   104,
      93,    94,    75,    95,    78,    42,    43,    84,    87,    76,
      77,    86,    80,   115,    85,    88,    89,   105,   103,   106,
     109,   117,   116,   118,   119,   108,    42,    96,   112,   120,
     121,   122,   114,   111,   129,   130,   131,   126,   125,   132,
     113,     0,     0,   128,     0,     0,     0,     0,     0,   112,
       0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   127,     0,     0,     0,     0,     0,     0,   112,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22
};

static const short yycheck[] =
{
       1,    19,     8,    76,     5,     6,    18,    20,     9,    22,
      11,    10,    85,    12,    13,     8,    41,     8,     8,    17,
      19,    12,    40,    13,    15,    16,    17,    18,    46,     9,
      48,    32,     8,     8,    33,    41,    54,    36,    13,    15,
       5,    10,    39,    40,     6,    63,    15,     6,    41,     5,
      41,    42,    53,     8,    15,    16,     5,    12,    10,    77,
      15,    16,     6,    18,    63,    41,    42,    66,    69,     6,
       5,     5,    15,    91,     6,    15,    14,     7,    77,     7,
      11,     6,    15,     7,     5,    86,    41,    42,    89,     7,
       5,     7,    91,    15,    11,     5,     7,   119,   117,   130,
      89,    -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,   110,
      -1,     0,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   121,    -1,    -1,    -1,    -1,    -1,    -1,   130,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    44,     0,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    45,    48,    50,    52,    58,    59,    18,
      39,    40,    46,     8,    13,    58,     8,    13,    58,    58,
       8,    15,    41,    42,    47,    58,     8,    47,     8,    47,
      47,    58,    61,    46,    46,     9,    17,    58,    47,    49,
      47,    51,    61,     5,     6,     6,     5,    53,    61,     5,
      61,    10,    60,    58,    61,     6,     6,     5,    47,    61,
      15,    15,    16,    57,    47,     6,     5,    58,    15,    14,
      62,     8,    12,    15,    16,    18,    42,    47,    54,    55,
      56,    61,    54,    47,    61,     7,     7,    54,    58,    11,
      10,    15,    58,    64,    47,    61,    15,     6,     7,     5,
       7,     5,     7,    63,    64,    57,    56,    47,    61,    11,
       5,     7,    63
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#define YYLEX	yylex ()

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;


int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 4:
#line 93 "parser.y"
    {}
    break;

  case 5:
#line 94 "parser.y"
    {Code_Start(yyvsp[0].str,1,yyvsp[-1].num);}
    break;

  case 6:
#line 95 "parser.y"
    {}
    break;

  case 7:
#line 96 "parser.y"
    {}
    break;

  case 8:
#line 97 "parser.y"
    {Pl_Fail();}
    break;

  case 9:
#line 98 "parser.y"
    {Pl_Ret();}
    break;

  case 10:
#line 99 "parser.y"
    {Jump(yyvsp[0].str);}
    break;

  case 11:
#line 100 "parser.y"
    {Move_From_Reg(yyvsp[-2].reg.name,yyvsp[-2].reg.no); 
					      Move_To_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no);
					      }
    break;

  case 12:
#line 103 "parser.y"
    {Move_Int_To_Reg(yyvsp[-2].num,yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 13:
#line 104 "parser.y"
    {Move_Int_To_Ident(yyvsp[-2].num,yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 14:
#line 105 "parser.y"
    {Move_Cst_To_Reg(yyvsp[-5].str[0],yyvsp[-3].num,yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 15:
#line 106 "parser.y"
    {Move_Cst_To_Ident(yyvsp[-5].str[0],yyvsp[-3].num,yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 16:
#line 107 "parser.y"
    { Read_Variable(yyvsp[-2].ident.ident,yyvsp[-2].ident.trail);
                                               Move_To_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 17:
#line 109 "parser.y"
    { Read_Variable(yyvsp[-2].ident.ident,yyvsp[-2].ident.trail);
                                               Move_Ret_To_Ident(yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 18:
#line 111 "parser.y"
    {}
    break;

  case 19:
#line 112 "parser.y"
    {Move_From_Reg(yyvsp[-2].reg.name,yyvsp[-2].reg.no); Jump_Not_Zero(yyvsp[0].str); }
    break;

  case 20:
#line 113 "parser.y"
    {Read_Variable(yyvsp[-2].ident.ident,yyvsp[-2].ident.trail); Jump_Not_Zero(yyvsp[0].str); }
    break;

  case 21:
#line 114 "parser.y"
    {Move_From_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no); Ret_Not_Zero(); }
    break;

  case 22:
#line 115 "parser.y"
    {Read_Variable(yyvsp[0].ident.ident,yyvsp[0].ident.trail); Ret_Not_Zero(); }
    break;

  case 23:
#line 116 "parser.y"
    {Jump_Ret();}
    break;

  case 24:
#line 117 "parser.y"
    {Fail_Ret();}
    break;

  case 25:
#line 118 "parser.y"
    {True_Ret();}
    break;

  case 26:
#line 119 "parser.y"
    {Fail_C_Ret();}
    break;

  case 27:
#line 120 "parser.y"
    {True_C_Ret();}
    break;

  case 28:
#line 121 "parser.y"
    {Move_To_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 29:
#line 122 "parser.y"
    {Move_Ret_To_Ident(yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 30:
#line 123 "parser.y"
    {Code_Start(yyvsp[0].str,0,yyvsp[-1].num);}
    break;

  case 31:
#line 124 "parser.y"
    {C_Ret();}
    break;

  case 32:
#line 125 "parser.y"
    {Data_Long(yyvsp[-1].ident.ident,yyvsp[-2].num,yyvsp[-1].ident.trail,yyvsp[0].initlonglist);}
    break;

  case 33:
#line 126 "parser.y"
    {Label(yyvsp[-1].str);}
    break;

  case 34:
#line 130 "parser.y"
    {yyval.num=0;}
    break;

  case 35:
#line 131 "parser.y"
    {yyval.num=1;}
    break;

  case 36:
#line 135 "parser.y"
    { yyval.reg.name=yyvsp[-3].str[0]; yyval.reg.no=yyvsp[-1].num; }
    break;

  case 37:
#line 139 "parser.y"
    {Pl_Call_Start(yyvsp[0].str,0); offset=0; kind_of_call=1; }
    break;

  case 38:
#line 140 "parser.y"
    {Pl_Jump(yyvsp[-4].str);}
    break;

  case 39:
#line 144 "parser.y"
    {Pl_Jump_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no); }
    break;

  case 40:
#line 148 "parser.y"
    {Pl_Jump_Star(); }
    break;

  case 41:
#line 152 "parser.y"
    {Pl_Call_Start(yyvsp[0].str,0); offset=0; kind_of_call=1; }
    break;

  case 42:
#line 153 "parser.y"
    {Pl_Call_Stop(yyvsp[-4].str,0); }
    break;

  case 43:
#line 157 "parser.y"
    {Pl_Call_Reg(yyvsp[0].reg.name,yyvsp[0].reg.no); }
    break;

  case 44:
#line 161 "parser.y"
    {Pl_Call_Star();}
    break;

  case 45:
#line 165 "parser.y"
    { Call_C_Start(yyvsp[0].str,0); offset=0; kind_of_call=0; }
    break;

  case 46:
#line 166 "parser.y"
    { Call_C_Stop(yyvsp[-4].str,0); }
    break;

  case 47:
#line 169 "parser.y"
    {}
    break;

  case 48:
#line 170 "parser.y"
    {}
    break;

  case 49:
#line 174 "parser.y"
    {}
    break;

  case 50:
#line 175 "parser.y"
    {}
    break;

  case 51:
#line 179 "parser.y"
    {offset += Call_Arg_Int(offset,yyvsp[0].num);}
    break;

  case 52:
#line 180 "parser.y"
    {offset += Call_Arg_Float(offset,yyvsp[0].fnum);}
    break;

  case 53:
#line 181 "parser.y"
    {offset += Call_Arg_String(offset,Add_String(yyvsp[0].str));}
    break;

  case 54:
#line 182 "parser.y"
    {offset += Call_Arg_Reg(offset,yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 55:
#line 183 "parser.y"
    {offset += Call_Arg_Reg_Variable(offset,yyvsp[0].reg.name,yyvsp[0].reg.no);}
    break;

  case 56:
#line 184 "parser.y"
    {offset += Call_Arg_Cst(offset,yyvsp[-3].str[0],yyvsp[-1].num);}
    break;

  case 57:
#line 185 "parser.y"
    {offset += Call_Arg_Param(offset,yyvsp[0].num);}
    break;

  case 58:
#line 186 "parser.y"
    {offset += Call_Arg_Label(offset,yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 59:
#line 187 "parser.y"
    {offset += Call_Arg_Variable(offset,yyvsp[0].ident.ident,yyvsp[0].ident.trail);}
    break;

  case 60:
#line 191 "parser.y"
    { yyval.num=yyvsp[0].num; }
    break;

  case 61:
#line 192 "parser.y"
    { yyval.num=float2long(yyvsp[0].fnum); }
    break;

  case 62:
#line 196 "parser.y"
    {in_ident=1;}
    break;

  case 63:
#line 196 "parser.y"
    {in_ident=0; yyval.str=yyvsp[0].str; }
    break;

  case 64:
#line 199 "parser.y"
    { yyval.num=0;  }
    break;

  case 65:
#line 200 "parser.y"
    { yyval.num=yyvsp[-1].num; }
    break;

  case 66:
#line 203 "parser.y"
    { yyval.ident.ident = yyvsp[-1].str; yyval.ident.trail = yyvsp[0].num; }
    break;

  case 67:
#line 206 "parser.y"
    { yyval.initlonglist=0; }
    break;

  case 68:
#line 207 "parser.y"
    { yyval.initlonglist=Init_Long_Add(yyvsp[0].initlongval.type,yyvsp[0].initlongval.value,0); }
    break;

  case 69:
#line 208 "parser.y"
    { yyval.initlonglist=yyvsp[-1].initlonglist; }
    break;

  case 70:
#line 211 "parser.y"
    { yyval.initlonglist=Init_Long_Add(yyvsp[0].initlongval.type,yyvsp[0].initlongval.value,0); }
    break;

  case 71:
#line 212 "parser.y"
    { yyval.initlonglist=Init_Long_Add(yyvsp[-2].initlongval.type,yyvsp[-2].initlongval.value,yyvsp[0].initlonglist); }
    break;

  case 72:
#line 215 "parser.y"
    { yyval.initlongval.type=1; yyval.initlongval.value=yyvsp[0].num; }
    break;

  case 73:
#line 216 "parser.y"
    { yyval.initlongval.type=0; yyval.initlongval.value=(long)yyvsp[0].str;  }
    break;


    }

/* Line 1016 of /usr/share/bison/yacc.c.  */
#line 1511 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 219 "parser.y"








